import java.io.*;
import java.net.*;
import java.util.*;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;


public class server {
	// static ArrayList<ArrayList<ServerThread>> gamelist = new ArrayList<ArrayList<ServerThread>>();
	static ArrayList<ServerThread> al = new ArrayList<ServerThread>();
	static ArrayList<Queue<String>> ql = new ArrayList<Queue<String>>();
	private static Scanner s;
	public static void main(String[] args) throws IOException, NoSuchAlgorithmException {
		initialize_questions();

		ServerSocket s_sock = new ServerSocket(1776);
		System.out.println("Server Established... Waiting for users...");

		boolean forming_lobby = true;
		while (forming_lobby) 
		{	
			connect_WebSocket_to_ServerThread(s_sock);
			forming_lobby = false;
			for (ServerThread x : al)
			{
				if (x.game_start == false)	
				{	forming_lobby = true;	}
			}
		}
	}

	static void connect_WebSocket_to_ServerThread(ServerSocket s_sock) {
		try {
			Socket sock = s_sock.accept();
			System.out.print("Client connected\n");
			
			/*----------------------------------------------------------------------------------*/
			// WebSocket Handshake Protocol -----------------------------------------------------/
			InputStream in = sock.getInputStream();
			OutputStream out = sock.getOutputStream();
			s = new Scanner(in, "UTF-8");
			try {
				String data = s.useDelimiter("\\r\\n\\r\\n").next();
				Matcher get = Pattern.compile("^GET").matcher(data);
				if (get.find()) {
					Matcher match = Pattern.compile("Sec-WebSocket-Key: (.*)").matcher(data);
					match.find();
					byte[] response = ("HTTP/1.1 101 Switching Protocols\r\n"
						+ "Connection: Upgrade\r\n"
						+ "Upgrade: websocket\r\n"
						+ "Sec-WebSocket-Accept: "
						+ Base64.getEncoder().encodeToString(MessageDigest.getInstance("SHA-1").digest((match.group(1) + "258EAFA5-E914-47DA-95CA-C5AB0DC85B11").getBytes("UTF-8")))
						+ "\r\n\r\n").getBytes("UTF-8");
					out.write(response, 0, response.length);
					out.flush();
					/*--------------------------------------------------------------------------*/
					// Passing WebSocket connection to new Server Thread ------------------------/
					ServerThread st = new ServerThread(sock, al.size() + 1, al, ql);
					al.add(st);
					st.start();
				}
			} catch (Exception e) { System.out.print("Some kind of error???"); }
		} catch (Exception e) {	System.out.println("Connection Error"); }
	}

	private static void initialize_questions() throws IOException 
	{
		String[] file_name_list = {"Geography.txt", "History.txt", "MoviesTV.txt", "Music.txt", "Mythology.txt", "Science.txt", "Sports.txt"};
		for (String file_name : file_name_list)
		{
			Queue<String> q = new PriorityQueue<String>();

			File f = new File("questions/"+file_name);
			BufferedReader buff = null;
			buff = new BufferedReader(new FileReader(f));
			System.out.print("Loading: " + f.getName() + "\n");
			while(buff.ready())
			{	q.add(buff.readLine());	}	// WRITES THE CONTENTS OF FILE TO Q
			ql.add(q);						// ADDS Q TO LIST OF Q'S
			buff.close();
		}
		for (Queue<String> x : ql)			// Randomizes the order of the questions in the queues one category at a time
		{
			Object[] array = x.toArray();
			for (var i = x.size() - 1; i > 0; i--) {
				var j = Math.floor(Math.random() * (i + 1));
				var temp = array[i];
				array[i] = array[(int)j];
				array[(int)j] = temp;
			}
			int orig_size = x.size();
			for (int i = 0; i < orig_size; i++)
			{	x.remove();	 }
			for(Object i : array)
			{	x.add((String) i);	}
		}
	}
}

class ServerThread extends Thread {
	ArrayList<ServerThread> al;	ArrayList<Queue<String>> ql;

	Socket sock = null;	

	int id;						// This Server Thread's Unique ID

	int round;					// The Round Number

	int point_total; 			// Total Points & Points gained in a specific round
	int round_points;

	boolean question_is_ready;	// Flags
	boolean done_with_answer;
	boolean scoreboard_exit;

	boolean selector;			// Selector Flag

	boolean game_start = false;	// Game Start/End Variables
	boolean game_over = false;
	int winner;

	boolean loop;

	String question;
	public ServerThread(Socket s, int x, ArrayList<ServerThread> y, ArrayList<Queue<String>> z) 
	{
		this.sock = s;	this.id = x;	this.al = y;	this.ql = z;

		this.point_total = 0;	this.round_points = 0;	this.round = 0;

		this.game_start = false;
	}

	public synchronized void run() {
		try {
			InputStream in = sock.getInputStream();
			OutputStream out = sock.getOutputStream();
			String in_data = null;
			byte[] out_data = null;

			if (this.id == 1)											// Player one is first selector
				selector = true;	
			else
				selector = false;	

			while(!game_start)
			{
				out_data = encode("0," + Integer.toString(al.size()));
				out.write(out_data, 0, out_data.length);
				if (decode(in).equals("ADVANCE"))
					game_start = true;	
			}
			loop = true;
			while(loop)												
			{	loop = false;
				for(ServerThread x : al)
					if (!x.game_start)
						loop = true;
			}


			question_is_ready = false; done_with_answer = false; scoreboard_exit = false;

			boolean forever = true;
			/*----------------------------------------------------------------------------------------------------------------------------*/
			/* GAME LOOP STARTS BELOW */
			while (forever) { 
				round++;
				if (selector == true)
				{
					SELECT_CATEGORY(in, out);
				}
				/*------------------------------------------------------------------------------------------------------------------------*/
				question_is_ready = true;
				loop = true;
				while(loop)												
				{	loop = false;
					for(ServerThread x : al)
						if (!x.question_is_ready)
							loop = true;
				}
				scoreboard_exit = false;
				/*------------------------------------------------------------------------------------------------------------------------*/
				String shuffled_question = shuffle(question);			// Shuffles the question's answers

				out_data = encode("2," + shuffled_question);			
				out.write(out_data, 0, out_data.length);				// Sends Question Data

				in_data = GET_INPUT(in);								// Recieves Answer Data

				point_total = Allocate_Points(out, in_data);

				/*------------------------------------------------------------------------------------------------------------------------*/
				done_with_answer = true;
				loop = true;
				while(loop)												
				{	loop = false;
					for(ServerThread x : al)
						if (!x.done_with_answer)
							loop = true;	
				}
				question_is_ready = false;
				/*------------------------------------------------------------------------------------------------------------------------*/
				
				if (selector == true)								// Just so not all of the ST's have to do the same calculations
				{
					Handle_Selector_Switching();
				}
				
				String temp = Compile_Scoreboard(question.split(","));		// Compiles the data to display in the scoreboard
				temp = Check_for_Winner(question.split(","), 300) + temp;	// Determines the winner and appends the scoreboard data to the end of message
				
				out_data = encode(temp);
				out.write(out_data);								// Sends Scoreboard Data
				
				GET_INPUT(in);										// Recieves flag to advance to next round

				/*------------------------------------------------------------------------------------------------------------------------*/
				scoreboard_exit = true;
				loop = true;
				while(loop)							
				{	loop = false;
					for(ServerThread x : al)
						if (!x.scoreboard_exit)
							loop = true;	
				}
				done_with_answer = false;
				/*------------------------------------------------------------------------------------------------------------------------*/
			}  
		} 
		catch (IOException e) {
			System.out.println("IO Error/ Client " + this.getName() + " terminated abruptly");
		}
		catch(NullPointerException e) {
			System.out.println("Client " + this.getName() + " Closed");
		}
		finally {    
			try
			{
				System.out.println("Connection Closing..");
				if (sock != null) 
				{
					sock.close();
					System.out.println("Socket Closed");
				}
				al.remove(this);
			} catch(IOException ie)	{	System.out.println("Socket Close Error");	}
		} /*end finally*/
	}
	/* END OF MAIN SERVER THREAD MAIN --------------------------------------------------------------------------------------------------- */

	/* Get Input ------------------------------------------------------------------------------------------------------------------------ */
	//
	//
	//
	private String GET_INPUT(InputStream in) {
		String in_data;
		try {														
			sock.setSoTimeout(30*1000);
			in_data = decode(in);
		} 
		catch (Exception e) {in_data = "Timed Out,0";}
		return in_data;
	}

	/* Select Category ------------------------------------------------------------------------------------------------------------------ */
	//
	//
	//
	private void SELECT_CATEGORY(InputStream in, OutputStream out) throws IOException {
		byte[] out_data;
		out_data = encode("1,dummy");
		loop = true;
		while(loop)	
		{
			out.write(out_data, 0, out_data.length);		// SENDS OPCODE
			
			int index = Integer.parseInt(decode(in));		// RECIEVES THE QUEUE TO PEEK ON FROM THE CLIENT
			question = ql.get(index).peek();				// GETS NEXT QUESTION

			System.out.println(question);

			if (question != null)							// If "question" is null then that question's queue is empty...
			{
				for (ServerThread x : al)
					x.question = question;					// SENDS QUESTION TO EVERY THREAD
				ql.get(index).remove();						// REMOVES THE QUESTION FROM THAT QUEUE TO PREVENT DUPLICATE QUESTIONS
				loop = false;
			}
		}
	}

	/* Handle Selector Switching -------------------------------------------------------------------------------------------------------- */
	//
	//
	//
	private void Handle_Selector_Switching() {
		ServerThread tempST = al.get(0);
		for (ServerThread x : al)
		{
			if (x.round_points > tempST.round_points)
				tempST = x;  
			else if (x.round_points == tempST.round_points)
			{
				if (x.point_total > tempST.point_total)
				 	tempST = x;	 
				else if (x.point_total == tempST.point_total)
				{
					if (x.selector == true)
						tempST = x;	 
					else if (x.selector == false && tempST.selector == false)
					{
						Random coinflip = new Random();
						if (coinflip.nextInt(2) == 1)
							tempST = x;	 
					}	// else do nothing cuz the other is already marked as the highest scorer
				}	// else do nothing cuz the other is already marked as the highest scorer
			}	// else do nothing cuz the other is already marked as the highest scorer
		}
		selector = false;
		al.get(al.indexOf(tempST)).selector = true;
	}

	/* Allocate Points ----------------------------------------------------------------------------------------------------------------- */
	//
	//
	//
	private int Allocate_Points(OutputStream out, String in_data) throws IOException {
		byte[] out_data;
		String [] q = question.split(",");						// Splits original question
		String [] a = in_data.split(",");						// Splits the message recieved
		if (q[1].equals(a[0]))									// Correct answer is stored in q[1], answer recieved is in a[0]
		{ 
			round_points = (int) (50 + ((Float.parseFloat(a[1]) + 1.0) / 30.0 / 2 * 100)); 
			out_data = encode("3,YOU'RE CORRECT! + " + round_points + "!");	
			out.write(out_data, 0, out_data.length);
		}
		else 
		{ 
			round_points = 0;
			out_data = encode("3,YOU'RE WRONG! + " + round_points + "!");	
			out.write(out_data, 0, out_data.length);
		}
		return point_total + round_points;
	}

	/* Compile Scoreboard ------------------------------------------------------------------------------------------------------------ */
	//
	//
	//
	private String Compile_Scoreboard(String[] q) {
		String temp = "";
		for (ServerThread x : al)								// Loop writes all scores and CSV packs them into temp	
			temp = temp + "," + "Player " + x.id + " Total: " + x.point_total + " (This Round: " + x.round_points + ")";
		return temp;
	}

	/* Check for Winner --------------------------------------------------------------------------------------------------------------- */
	//
	//
	//
	private String Check_for_Winner(String [] q, int target_points) {
		String temp = "";
		ServerThread tempST = al.get(0);
		for (ServerThread x : al)
		{
			if (x.point_total >= target_points)
			{
				game_over = true;

				if (x.point_total > tempST.point_total)			// If x's point total is higher than the other player's score
					tempST = x;
				else if (x.point_total == tempST.point_total)	// If a tie between two people who reached target score play another round
					game_over = false;
			}
		}

		if (game_over == true)
			temp = "10,Game Over!\nPlayer " + tempST.id + " wins!";	 
		else
		 	temp = "4,Round " + round + ": \nCorrect Answer: " + q[1];	
		return temp;
	}

	private String shuffle(String str) {
		String[] str_array = str.split(",");
		String question = str_array[0];
		for (var i = str_array.length - 1; i > 0; i--) {
			var j = Math.floor(Math.random() * (i + 1));
			var temp = str_array[i];
			str_array[i] = str_array[(int) j];
			str_array[(int) j] = temp;
		}
		int i = 0;
		boolean keepgoing = true;
		String temp;
		while (keepgoing) {
			if (str_array[i] == question) {
				temp = str_array[0];
				str_array[0] = question;
				str_array[i] = temp;
				keepgoing = false;
			}
			i++;
		}
		str = "";
		for(String s : str_array)
		{
			str = str + s + ",";
		}
		return str;
	}

	private static String decode(InputStream in) throws IOException {
		byte[] byte_in = new byte[1024];
		int size = in.read(byte_in);
		if (size != -1)
		{
			byte[] decoded = new byte[size-6];
			byte[] key = new byte[]{ byte_in[2], byte_in[3], byte_in[4], byte_in[5] };
			for (int i = 0; i < size-6; i++) 
			{	decoded[i] = (byte) (byte_in[i+6] ^ key[i & 0x3]);  }
			return new String(decoded, "UTF-8");
		}
		else return null;
	}

	public static byte[] encode(String mess) throws IOException{
		byte[] rawData = mess.getBytes();

        int frameCount  = 0;
        byte[] frame = new byte[10];

        frame[0] = (byte) 129;

        if(rawData.length <= 125){
            frame[1] = (byte) rawData.length;
            frameCount = 2;
        }else if(rawData.length >= 126 && rawData.length <= 65535){
            frame[1] = (byte) 126;
            int len = rawData.length;
            frame[2] = (byte)((len >> 8 ) & (byte)255);
            frame[3] = (byte)(len & (byte)255); 
            frameCount = 4;
        }else{
            frame[1] = (byte) 127;
            int len = rawData.length;
            frame[2] = (byte)((len >> 56 ) & (byte)255);
            frame[3] = (byte)((len >> 48 ) & (byte)255);
            frame[4] = (byte)((len >> 40 ) & (byte)255);
            frame[5] = (byte)((len >> 32 ) & (byte)255);
            frame[6] = (byte)((len >> 24 ) & (byte)255);
            frame[7] = (byte)((len >> 16 ) & (byte)255);
            frame[8] = (byte)((len >> 8 ) & (byte)255);
            frame[9] = (byte)(len & (byte)255);
            frameCount = 10;
        }

        int bLength = frameCount + rawData.length;

        byte[] reply = new byte[bLength];

        int bLim = 0;
        for(int i=0; i<frameCount;i++){
            reply[bLim] = frame[i];
            bLim++;
        }
        for(int i=0; i<rawData.length;i++){
            reply[bLim] = rawData[i];
            bLim++;
        }

        return reply;
    }
}